//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class VerletIntegrator : Integrator {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal VerletIntegrator(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.VerletIntegrator_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(VerletIntegrator obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~VerletIntegrator() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_VerletIntegrator(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public VerletIntegrator(double stepSize) : this(OpenMMSwigPINVOKE.new_VerletIntegrator(stepSize), true) {
  }

  public override void step(int steps) {
    OpenMMSwigPINVOKE.VerletIntegrator_step(swigCPtr, steps);
  }

}

}
